/* $Id: 384a084ae5f074bf342195a3643cd19fb73ad8c7 $
   rotation.h */
#ifndef VRT_ROTATION_H
#define VRT_ROTATION_H

#include "progscope.h"

#ifdef VRT_RENDERER_GL
#define rxy_vf(v, r) rxy_vrt_vf(v, r)
#define rzx_vf(v, r) rzx_gl_vf(v, r)
#define rxz_vf(v, r) rzx_gl_vf(v, r)
#define ryz_vf(v, r) ryz_gl_vf(v, r)
#endif /* VRT_RENDERER_GL */

void rxy_vrt_vf(vf_t * pv, float ang_dpl);
void rzx_gl_vf(vf_t * pv, float ang_dpl);
void ryz_gl_vf(vf_t * pv, float ang_dpl);
float deg_to_radf(float deg);

#endif /* VRT_ROTATION_H */
