
/* $Id: 2e1dfe52e559c4aab5476b118297b943402703b9 $
   transform.c: hmap transforms.
   Copyright (C) 2012 J. A. Green <green8@sdf-eu.org>, If copyright allows, please addend copyright to additions to this source.
   lic: GNU GPL v3, see COPYING
*/
#include <unistd.h>
#include <stdlib.h>
#include "progscope.h"
#include "hmap.h"
#include "vectors.h"

/*
   hapticNormill: ... 
*/
void hapticNormill(select_t * sel) {
	/* j: i will beta test this */
}

/*
   transform path on vob intersection.
   where bound vol geom's intersected, calculate intersection of draw geom's
   for 2 vob's.  adjust attribs of both accordingly
*/
int intersection(select_t * sel) {
	/* ... */
	/* hmapf_t ** a, ** b;
	   btoggles_t t;
	   a = sel->seta; b = sel->setb;
	   t = sel->specbits;
	   __builtin_printf("transform: %i\n", (*(sel->seta))->index); */
	return 0;
}

/*
   allow hmaps to share intersection, attach etc...  requires tending to
   session_filter and data via perhaps rname_hmapf(), enter_group(),
   leave_group(), and group_groups(), all based on hmap session_filter and name.
*/
int group_hmaps(select_t * sel) {
	return 0;
}

/*
   join selected vobs.
*/
void join (select_t * sel) {
	;
}

/*
   send vobs to recycler.
   the recycler could be written to function as undo stack per vob
   dependant on session name, and perhaps via future supporting data.c.
*/
void recycler(select_t * sel) {
	;
}

/*
   put hmap in selection buf to vobfile
   for now assume written to file/network
*/
meta_u a_file_net_io[10000];
void hmapwrapf(select_t * sel) {

	int * pb = (int *)a_file_net_io;
	int * d, * pi = (int *)&a_file_net_io[1];
	float * pf;
	int i = 0;
	int j = 0;
	hmapf_t * h;
	vf_t * v;

	h = *(sel->seta);
	*pi++ = (int)h->name >> 16; /* ... */
	*pi++ = (int)h->name;
	*pi++ = h->index;
	*pi++ = h->bounding.geom;
	*pi++ = h->draw.geom;
	*pi++ = h->attribs.bits;
	*pi++ = h->attribs.session_filter;
	*pi++ = h->attribs.balance_filter;
	*pi++ = h->mass.kfactor;
	*pi++ = h->kfactor;
	*pi++ = h->vf_total;
	pf = (float *)pi;
	*pf++ = h->v_pos.x;
	*pf++ = h->v_pos.y;
	*pf++ = h->v_pos.z;
	*pf++ = h->v_pos.m;
	*pf++ = h->v_vel.x;
	*pf++ = h->v_vel.y;
	*pf++ = h->v_vel.z;
	*pf++ = h->v_vel.m;
	*pf++ = h->v_axi.x;
	*pf++ = h->v_axi.y;
	*pf++ = h->v_axi.z;
	*pf++ = h->v_axi.m;
	*pf++ = h->ang_spd;
	*pf++ = h->ang_dpl;
	*pf++ = h->mass.kg;
	*pf++ = h->bounding.v_sz.x;
	*pf++ = h->bounding.v_sz.y;
	*pf++ = h->bounding.v_sz.z;
	*pf++ = h->bounding.v_sz.m;
	v = h->p_data_vf;
	while(i++ < h->vf_total) {
		*pf++ = v->x;
		*pf++ = v->y;
		*pf++ = v->z;
		*pf++ = v->m;
		v++;
	}
	pi = (int *)pf;
	*pi++ = h->dialog_total;
	d = h->p_dialog;
	while(j++ < h->dialog_total)
		*pi++ = *d++;
	*pb = abs((int)pi - (int)pb) / sizeof(int);
}

/*
   meta_u a_file_net_io[10000] assume file/network written to hmap
   for now just print from file
*/
int hmapunwrapf(select_t * sel) {

	float * fl = (float *)a_file_net_io;
	int i, * in = (int *)a_file_net_io;

	__builtin_printf("hmap total: %i\n", (int)*in++); fl++;
	__builtin_printf("vobnum: %i:%i\n", (int)*in++, (int)*in++); fl++; fl++;
	__builtin_printf("index: %i\n", (int)*in++); fl++;
	__builtin_printf("bound geom: %i\n", (int)*in++); fl++;
	__builtin_printf("draw geom: %i\n", (int)*in++); fl++;
	__builtin_printf("attribs bits: %i\n", (int)*in++); fl++;
	__builtin_printf("session filter: %i\n", (int)*in++); fl++;
	__builtin_printf("balance filter: %i\n", (int)*in++); fl++;
	__builtin_printf("mass factor: %i\n", (int)*in++); fl++;
	__builtin_printf("factor: %i\n", (int)*in++); fl++;
	int vf_total = (int)*in;
	__builtin_printf("vf_total: %i\n", (int)*in++); fl++;
	__builtin_printf("pos: %f %f %f %f\n", \
		(float)*fl++, (float)*fl++, (float)*fl++, (float)*fl++);
	in++; in++; in++; in++;	
	__builtin_printf("vel: %f %f %f %f\n", \
		(float)*fl++, (float)*fl++, (float)*fl++, (float)*fl++);
	in++; in++; in++; in++;	
	__builtin_printf("axi: %f %f %f %f\n", \
		(float)*fl++, (float)*fl++, (float)*fl++, (float)*fl++);
	in++; in++; in++; in++;	
	__builtin_printf("ang_spd: %f\n", (float)*fl++); in++;
	__builtin_printf("ang_dpl: %f\n", (float)*fl++); in++;
	__builtin_printf("kg: %f\n", (float)*fl++); in++;
	__builtin_printf("bound size: %f %f %f %f\n", \
		(float)*fl++, (float)*fl++, (float)*fl++, (float)*fl++);
	in++; in++; in++; in++;	
	i=0;
	while(i < vf_total) {
		__builtin_printf("vf %i: %f", i, (float)*fl++); in++;
		__builtin_printf(" %f", (float)*fl++); in++;
		__builtin_printf(" %f", (float)*fl++); in++;
		__builtin_printf(" %f\n", (float)*fl++); in++;
		i++;
	}
	int dialog_total = (int)*in;
	__builtin_printf("dialog_total: %i\n", (int)*in++); fl++;
	i=0;
	__builtin_printf("dialog follows\n");
	while(i < dialog_total) {
		for(;!(i%8);i++)
			__builtin_printf("%x", (int)*in++); fl++;
	}
	__builtin_printf("\n");
	return 0;
}

/*
   preset dialog_total in &sel_a[0] to new value before calling
*/
int alloc_dialog(select_t * sel) {
	free((*sel->seta)->p_dialog);
	(*sel->seta)->p_dialog = (int *) \
		malloc((*sel->seta)->dialog_total * sizeof(int));
	return 0;
}

/*
   hmap copy made less name/index retained by recieving hmap
*/
void copy_hmapf(select_t * sel) {

	hmapf_t * a, * b;
	vf_t * v, * w;
	int i, j, * d, * e;

	a = *(sel->seta);
	b = *(sel->setb);
	b->v_vel.x = a->v_vel.x;
	b->v_vel.y = a->v_vel.y;
	b->v_vel.z = a->v_vel.z;
	b->v_vel.m = a->v_vel.m;
	b->v_axi.x = a->v_axi.x;
	b->v_axi.y = a->v_axi.y;
	b->v_axi.z = a->v_axi.z;
	b->v_axi.m = a->v_axi.m;
	b->ang_spd = a->ang_spd;
	b->ang_dpl = a->ang_dpl;
	b->mass.kg = a->mass.kg;
	b->mass.kfactor = a->mass.kfactor;
	b->kfactor = a->kfactor;
	b->bounding.geom = a->bounding.geom;
	b->bounding.v_sz.x = a->bounding.v_sz.x;
	b->bounding.v_sz.y = a->bounding.v_sz.y;
	b->bounding.v_sz.z = a->bounding.v_sz.z;
	b->bounding.v_sz.m = a->bounding.v_sz.m;
	b->draw.geom = a->draw.geom;
	b->attribs = a->attribs;
	b->vf_total = a->vf_total;
	free(b->p_data_vf);
	b->p_data_vf = (vf_t *) malloc(a->vf_total * sizeof(vf_t));
	v = a->p_data_vf;
	w = b->p_data_vf;
	for(i=0;i<a->vf_total;i++, v++) {
		w->x = v->x;
		w->y = v->y;
		w->z = v->z;
		w->m = v->m;
	}
	free(b->p_dialog);
	b->p_dialog = (int *) malloc(a->dialog_total * sizeof(int));
	d = a->p_dialog;
	e = b->p_dialog;
	for(j=0;j<a->dialog_total;j++)
		*e++ = *d++;
}
