
/* $Id: b3d73d4f9439821f6e73abce9b8f367896d83b44 $
   tug.c: tend to any extra pertainant system bus i/o for implicit node.
   Copyright (C) 2012 J. A. Green <green8@sdf-eu.org>, If copyright allows, please addend copyright to additions to this source.
   lic: GNU GPL v3, see COPYING
*/

#include "progscope.h"
#include "generator.h"
#include "transform.h"

/* add transform recipie qualifiers below to match transform.c */
enum {
	VRT_HAPTIC_NORMILL,
	VRT_INTERSECTION
};
void call_hapticNormill();
void call_intersection();
void (*fparr[])() = {
	&call_hapticNormill,
	&call_intersection
};
void call_hapticNormill(void) {
	generator_hapticNormill();
}
void call_intersection(void) {
	generator_intersection();
}

/* call a transform recipie. vob(s) will have already been selected. */
void transform(int recipe) {
	(*fparr[recipe])();
}

int init_tug_io(void) {
	return 0;
}
